/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the OrganizationUserInvitation type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &OrganizationUserInvitation{}

// OrganizationUserInvitation `Email` and other user details are only needed with mode `new`. For existing users invitation `user_ids` are required, and optionally `channel_ids` with target `channels`.  Valid permissions for organization:  - `40` for owner  - `30` for admin   Valid permissions for channels:  - `30` for admin  - `20` for editor  - `10` for reader  
type OrganizationUserInvitation struct {
	Target string `json:"target"`
	Mode string `json:"mode"`
	Permission int32 `json:"permission"`
	Email *string `json:"email,omitempty"`
	Channels []string `json:"channels,omitempty"`
	UserIds []string `json:"user_ids,omitempty"`
	FirstName *string `json:"first_name,omitempty"`
	LastName *string `json:"last_name,omitempty"`
	Company *string `json:"company,omitempty"`
	Department *string `json:"department,omitempty"`
	JobTitle *string `json:"job_title,omitempty"`
	Info *string `json:"info,omitempty"`
	ExternalIds map[string]interface{} `json:"external_ids,omitempty"`
	Tags []string `json:"tags,omitempty"`
}

// NewOrganizationUserInvitation instantiates a new OrganizationUserInvitation object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewOrganizationUserInvitation(target string, mode string, permission int32) *OrganizationUserInvitation {
	this := OrganizationUserInvitation{}
	this.Target = target
	this.Mode = mode
	this.Permission = permission
	return &this
}

// NewOrganizationUserInvitationWithDefaults instantiates a new OrganizationUserInvitation object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewOrganizationUserInvitationWithDefaults() *OrganizationUserInvitation {
	this := OrganizationUserInvitation{}
	return &this
}

// GetTarget returns the Target field value
func (o *OrganizationUserInvitation) GetTarget() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Target
}

// GetTargetOk returns a tuple with the Target field value
// and a boolean to check if the value has been set.
func (o *OrganizationUserInvitation) GetTargetOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Target, true
}

// SetTarget sets field value
func (o *OrganizationUserInvitation) SetTarget(v string) {
	o.Target = v
}

// GetMode returns the Mode field value
func (o *OrganizationUserInvitation) GetMode() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Mode
}

// GetModeOk returns a tuple with the Mode field value
// and a boolean to check if the value has been set.
func (o *OrganizationUserInvitation) GetModeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Mode, true
}

// SetMode sets field value
func (o *OrganizationUserInvitation) SetMode(v string) {
	o.Mode = v
}

// GetPermission returns the Permission field value
func (o *OrganizationUserInvitation) GetPermission() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Permission
}

// GetPermissionOk returns a tuple with the Permission field value
// and a boolean to check if the value has been set.
func (o *OrganizationUserInvitation) GetPermissionOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Permission, true
}

// SetPermission sets field value
func (o *OrganizationUserInvitation) SetPermission(v int32) {
	o.Permission = v
}

// GetEmail returns the Email field value if set, zero value otherwise.
func (o *OrganizationUserInvitation) GetEmail() string {
	if o == nil || IsNil(o.Email) {
		var ret string
		return ret
	}
	return *o.Email
}

// GetEmailOk returns a tuple with the Email field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrganizationUserInvitation) GetEmailOk() (*string, bool) {
	if o == nil || IsNil(o.Email) {
		return nil, false
	}
	return o.Email, true
}

// HasEmail returns a boolean if a field has been set.
func (o *OrganizationUserInvitation) HasEmail() bool {
	if o != nil && !IsNil(o.Email) {
		return true
	}

	return false
}

// SetEmail gets a reference to the given string and assigns it to the Email field.
func (o *OrganizationUserInvitation) SetEmail(v string) {
	o.Email = &v
}

// GetChannels returns the Channels field value if set, zero value otherwise.
func (o *OrganizationUserInvitation) GetChannels() []string {
	if o == nil || IsNil(o.Channels) {
		var ret []string
		return ret
	}
	return o.Channels
}

// GetChannelsOk returns a tuple with the Channels field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrganizationUserInvitation) GetChannelsOk() ([]string, bool) {
	if o == nil || IsNil(o.Channels) {
		return nil, false
	}
	return o.Channels, true
}

// HasChannels returns a boolean if a field has been set.
func (o *OrganizationUserInvitation) HasChannels() bool {
	if o != nil && !IsNil(o.Channels) {
		return true
	}

	return false
}

// SetChannels gets a reference to the given []string and assigns it to the Channels field.
func (o *OrganizationUserInvitation) SetChannels(v []string) {
	o.Channels = v
}

// GetUserIds returns the UserIds field value if set, zero value otherwise.
func (o *OrganizationUserInvitation) GetUserIds() []string {
	if o == nil || IsNil(o.UserIds) {
		var ret []string
		return ret
	}
	return o.UserIds
}

// GetUserIdsOk returns a tuple with the UserIds field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrganizationUserInvitation) GetUserIdsOk() ([]string, bool) {
	if o == nil || IsNil(o.UserIds) {
		return nil, false
	}
	return o.UserIds, true
}

// HasUserIds returns a boolean if a field has been set.
func (o *OrganizationUserInvitation) HasUserIds() bool {
	if o != nil && !IsNil(o.UserIds) {
		return true
	}

	return false
}

// SetUserIds gets a reference to the given []string and assigns it to the UserIds field.
func (o *OrganizationUserInvitation) SetUserIds(v []string) {
	o.UserIds = v
}

// GetFirstName returns the FirstName field value if set, zero value otherwise.
func (o *OrganizationUserInvitation) GetFirstName() string {
	if o == nil || IsNil(o.FirstName) {
		var ret string
		return ret
	}
	return *o.FirstName
}

// GetFirstNameOk returns a tuple with the FirstName field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrganizationUserInvitation) GetFirstNameOk() (*string, bool) {
	if o == nil || IsNil(o.FirstName) {
		return nil, false
	}
	return o.FirstName, true
}

// HasFirstName returns a boolean if a field has been set.
func (o *OrganizationUserInvitation) HasFirstName() bool {
	if o != nil && !IsNil(o.FirstName) {
		return true
	}

	return false
}

// SetFirstName gets a reference to the given string and assigns it to the FirstName field.
func (o *OrganizationUserInvitation) SetFirstName(v string) {
	o.FirstName = &v
}

// GetLastName returns the LastName field value if set, zero value otherwise.
func (o *OrganizationUserInvitation) GetLastName() string {
	if o == nil || IsNil(o.LastName) {
		var ret string
		return ret
	}
	return *o.LastName
}

// GetLastNameOk returns a tuple with the LastName field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrganizationUserInvitation) GetLastNameOk() (*string, bool) {
	if o == nil || IsNil(o.LastName) {
		return nil, false
	}
	return o.LastName, true
}

// HasLastName returns a boolean if a field has been set.
func (o *OrganizationUserInvitation) HasLastName() bool {
	if o != nil && !IsNil(o.LastName) {
		return true
	}

	return false
}

// SetLastName gets a reference to the given string and assigns it to the LastName field.
func (o *OrganizationUserInvitation) SetLastName(v string) {
	o.LastName = &v
}

// GetCompany returns the Company field value if set, zero value otherwise.
func (o *OrganizationUserInvitation) GetCompany() string {
	if o == nil || IsNil(o.Company) {
		var ret string
		return ret
	}
	return *o.Company
}

// GetCompanyOk returns a tuple with the Company field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrganizationUserInvitation) GetCompanyOk() (*string, bool) {
	if o == nil || IsNil(o.Company) {
		return nil, false
	}
	return o.Company, true
}

// HasCompany returns a boolean if a field has been set.
func (o *OrganizationUserInvitation) HasCompany() bool {
	if o != nil && !IsNil(o.Company) {
		return true
	}

	return false
}

// SetCompany gets a reference to the given string and assigns it to the Company field.
func (o *OrganizationUserInvitation) SetCompany(v string) {
	o.Company = &v
}

// GetDepartment returns the Department field value if set, zero value otherwise.
func (o *OrganizationUserInvitation) GetDepartment() string {
	if o == nil || IsNil(o.Department) {
		var ret string
		return ret
	}
	return *o.Department
}

// GetDepartmentOk returns a tuple with the Department field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrganizationUserInvitation) GetDepartmentOk() (*string, bool) {
	if o == nil || IsNil(o.Department) {
		return nil, false
	}
	return o.Department, true
}

// HasDepartment returns a boolean if a field has been set.
func (o *OrganizationUserInvitation) HasDepartment() bool {
	if o != nil && !IsNil(o.Department) {
		return true
	}

	return false
}

// SetDepartment gets a reference to the given string and assigns it to the Department field.
func (o *OrganizationUserInvitation) SetDepartment(v string) {
	o.Department = &v
}

// GetJobTitle returns the JobTitle field value if set, zero value otherwise.
func (o *OrganizationUserInvitation) GetJobTitle() string {
	if o == nil || IsNil(o.JobTitle) {
		var ret string
		return ret
	}
	return *o.JobTitle
}

// GetJobTitleOk returns a tuple with the JobTitle field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrganizationUserInvitation) GetJobTitleOk() (*string, bool) {
	if o == nil || IsNil(o.JobTitle) {
		return nil, false
	}
	return o.JobTitle, true
}

// HasJobTitle returns a boolean if a field has been set.
func (o *OrganizationUserInvitation) HasJobTitle() bool {
	if o != nil && !IsNil(o.JobTitle) {
		return true
	}

	return false
}

// SetJobTitle gets a reference to the given string and assigns it to the JobTitle field.
func (o *OrganizationUserInvitation) SetJobTitle(v string) {
	o.JobTitle = &v
}

// GetInfo returns the Info field value if set, zero value otherwise.
func (o *OrganizationUserInvitation) GetInfo() string {
	if o == nil || IsNil(o.Info) {
		var ret string
		return ret
	}
	return *o.Info
}

// GetInfoOk returns a tuple with the Info field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrganizationUserInvitation) GetInfoOk() (*string, bool) {
	if o == nil || IsNil(o.Info) {
		return nil, false
	}
	return o.Info, true
}

// HasInfo returns a boolean if a field has been set.
func (o *OrganizationUserInvitation) HasInfo() bool {
	if o != nil && !IsNil(o.Info) {
		return true
	}

	return false
}

// SetInfo gets a reference to the given string and assigns it to the Info field.
func (o *OrganizationUserInvitation) SetInfo(v string) {
	o.Info = &v
}

// GetExternalIds returns the ExternalIds field value if set, zero value otherwise.
func (o *OrganizationUserInvitation) GetExternalIds() map[string]interface{} {
	if o == nil || IsNil(o.ExternalIds) {
		var ret map[string]interface{}
		return ret
	}
	return o.ExternalIds
}

// GetExternalIdsOk returns a tuple with the ExternalIds field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrganizationUserInvitation) GetExternalIdsOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.ExternalIds) {
		return map[string]interface{}{}, false
	}
	return o.ExternalIds, true
}

// HasExternalIds returns a boolean if a field has been set.
func (o *OrganizationUserInvitation) HasExternalIds() bool {
	if o != nil && !IsNil(o.ExternalIds) {
		return true
	}

	return false
}

// SetExternalIds gets a reference to the given map[string]interface{} and assigns it to the ExternalIds field.
func (o *OrganizationUserInvitation) SetExternalIds(v map[string]interface{}) {
	o.ExternalIds = v
}

// GetTags returns the Tags field value if set, zero value otherwise.
func (o *OrganizationUserInvitation) GetTags() []string {
	if o == nil || IsNil(o.Tags) {
		var ret []string
		return ret
	}
	return o.Tags
}

// GetTagsOk returns a tuple with the Tags field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrganizationUserInvitation) GetTagsOk() ([]string, bool) {
	if o == nil || IsNil(o.Tags) {
		return nil, false
	}
	return o.Tags, true
}

// HasTags returns a boolean if a field has been set.
func (o *OrganizationUserInvitation) HasTags() bool {
	if o != nil && !IsNil(o.Tags) {
		return true
	}

	return false
}

// SetTags gets a reference to the given []string and assigns it to the Tags field.
func (o *OrganizationUserInvitation) SetTags(v []string) {
	o.Tags = v
}

func (o OrganizationUserInvitation) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o OrganizationUserInvitation) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["target"] = o.Target
	toSerialize["mode"] = o.Mode
	toSerialize["permission"] = o.Permission
	if !IsNil(o.Email) {
		toSerialize["email"] = o.Email
	}
	if !IsNil(o.Channels) {
		toSerialize["channels"] = o.Channels
	}
	if !IsNil(o.UserIds) {
		toSerialize["user_ids"] = o.UserIds
	}
	if !IsNil(o.FirstName) {
		toSerialize["first_name"] = o.FirstName
	}
	if !IsNil(o.LastName) {
		toSerialize["last_name"] = o.LastName
	}
	if !IsNil(o.Company) {
		toSerialize["company"] = o.Company
	}
	if !IsNil(o.Department) {
		toSerialize["department"] = o.Department
	}
	if !IsNil(o.JobTitle) {
		toSerialize["job_title"] = o.JobTitle
	}
	if !IsNil(o.Info) {
		toSerialize["info"] = o.Info
	}
	if !IsNil(o.ExternalIds) {
		toSerialize["external_ids"] = o.ExternalIds
	}
	if !IsNil(o.Tags) {
		toSerialize["tags"] = o.Tags
	}
	return toSerialize, nil
}

type NullableOrganizationUserInvitation struct {
	value *OrganizationUserInvitation
	isSet bool
}

func (v NullableOrganizationUserInvitation) Get() *OrganizationUserInvitation {
	return v.value
}

func (v *NullableOrganizationUserInvitation) Set(val *OrganizationUserInvitation) {
	v.value = val
	v.isSet = true
}

func (v NullableOrganizationUserInvitation) IsSet() bool {
	return v.isSet
}

func (v *NullableOrganizationUserInvitation) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableOrganizationUserInvitation(val *OrganizationUserInvitation) *NullableOrganizationUserInvitation {
	return &NullableOrganizationUserInvitation{value: val, isSet: true}
}

func (v NullableOrganizationUserInvitation) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableOrganizationUserInvitation) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


